{ pkgs, ... }:
{
  imports = [
    ./desktop-software.nix
    ./fonts.nix
  ];

  environment.systemPackages = with pkgs; [
    kdePackages.okular
    vlc
  ];

  programs.kde-pim = {
    enable = true;
    kmail = true;
    kontact = true;
    merkuro = true;
  };

  # Enable sound.
  security.rtkit.enable = true;
  services.pipewire = {
    enable = true;
    alsa.enable = true;
    pulse.enable = true;
  };

  programs.zsh.vteIntegration = true;
  programs.bash.vteIntegration = true;

  hardware.bluetooth.enable = true;

  services.displayManager.sddm = {
    enable = true;
    wayland.enable = true;
  };

  services.desktopManager.plasma6.enable = true;
  programs.firefox.nativeMessagingHosts.packages = with pkgs.kdePackages; [
    plasma-browser-integration
  ];
}
